/*
 * ReadTag.java
 */

import java.io.*;
import java.net.*;

public class ReadTag {
   /** ReadTag IuWFNgǂݎtqk */
    protected URL myURL = null;
    /** ̃IuWFNgReader */
    protected BufferedReader inrdr = null;

    /** ReadTagNX̎ĝЂƂȒPȃCvO */
    public static void main(String[] args)
	throws MalformedURLException, IOException {
	if (args.length == 0) {
	    System.err.println("Usage:ReadTag URL [...]");
	    return;
	}
	for (int i = 0; i < args.length; i++) {
	    ReadTag rt = new ReadTag(args[0]);
	    String tag;
	    while ((tag = rt.nextTag()) != null) {
		System.out.println(tag);
	    }
	    rt.close();
	}
    }

    /** ^ꂽtqk̕ReadTag𐶐 */
    public ReadTag(String theURLString)
	throws IOException, MalformedURLException {
	this(new URL(theURLString));
    }

    /** ^ꂽtqkReadTag𐶐 */
    public ReadTag(URL theURL) throws IOException {
	myURL = theURL;
	// ǂݎ̑ΏۂƂȂtqkJ
	try{
	    inrdr = new BufferedReader(new InputStreamReader(myURL.openStream(),"JISAutoDetect"));
	}catch(Exception e){
	    System.out.print(" Not Page  ");
	    //System.out.println("error1:"+e.getMessage());
	}
    }


    /** ̃^Oǂ */
    public String nextTag() throws IOException {
	int i;

	while ((i = inrdr.read()) != -1) {
	    char thisChar = (char) i;
	    if (thisChar == '<') {
		String tag = readTag();
		return tag;
	    }
	}
	return null;
    }

    public void close() throws IOException {
	inrdr.close();
    }

    /** ^OǂށBElliotte Rusty Harold̃R[hpĂ */
    protected String readTag() throws IOException {
	StringBuffer theTag = new StringBuffer("<");
	int i = '<';

	while (i != '>' && (i = inrdr.read()) != -1) {
	    theTag.append((char) i);
	}
	return theTag.toString();
    }

    /** ̃IuWFNg\StringԂ */
    public String toString() {
	return "ReadTag[" + myURL.toString() + "]";
    }

}
